unit Edit;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, Buttons;

type
  TEditForm = class(TForm)
    PanelEditSpeed: TPanel;
    PanelEdit: TPanel;
    PanelColor: TPanel;
    ImageColor: TImage;
    BoxPruchod: TCheckBox;
    ButtonEnter: TSpeedButton;
    ButtonEsc: TSpeedButton;
    ImageEsc: TImage;
    ImageEnter: TImage;
    ButtonNahoru: TSpeedButton;
    ButtonDolu: TSpeedButton;
    ButtonVpravo: TSpeedButton;
    ButtonVlevo: TSpeedButton;
    LabelEditNum: TLabel;
    PanelStatus: TPanel;
    PanelImageEdit: TPanel;
    ImageEdit: TImage;
    SaveDialogEdit: TSaveDialog;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ButtonEscClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Zobraz;
    procedure ZobrazCol;
    procedure FormResize(Sender: TObject);
    procedure ButtonNahoruClick(Sender: TObject);
    procedure ButtonDoluClick(Sender: TObject);
    procedure ButtonVlevoClick(Sender: TObject);
    procedure ButtonVpravoClick(Sender: TObject);
    procedure ImageEditMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ImageColorMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImageEditMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ButtonEnterClick(Sender: TObject);
    procedure BoxPruchodClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    function EditUloz: Boolean;
    procedure LoadResTxt;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  procedure SaveBanka(Jmeno: string);

const
  ColHeight = 20;
  ColWidth = 25;

var
  EditForm: TEditForm;
  EditBitmap: TBitmap;
  EditWidth: Integer;
  EditHeight: Integer;
  EditXNum: Integer;
  EditYNum: Integer;

  EditBarva: Integer;
  EditTrans: Integer;
  EditModi: Boolean;

  EditaceTxt: string;        { text "- editace pedmtu" }
  EditModiText: string;

implementation

uses Main;
{$R *.DFM}

var
  EditColor:  array [0..IconPageNum-1] of Shortint;  { index masky, -1=nen }
  EditPruchod: array [0..IconPageNum-1] of Byte;    { 1=prchodn, 0=nen }

procedure StorBank(Banky: PBanks; Jmeno, AktDir: string);
var Banka: Integer;
    I: Integer;
begin
  if (Jmeno = EditName) and (AktDir = EditAktDir) then
  begin
    Banka := (EditForm.Tag-1) div 1000;
    with Banky^[Banka]^ do
    begin
      if not Assigned(bnBitmap) then
      begin
        bnBitmap := TBitmap.Create;
        bnBitmap.Width := IconXNum*IconWidth;
        bnBitmap.Height := IconYNum*IconHeight;
        bnBitmap.Palette := MainForm.InitPal;
      end;
      with bnBitmap do
        Canvas.CopyRect(
          Rect(0,0,Width,Height),
          EditBitmap.Canvas,
          Rect(0,0,Width,Height));
      for I := 0 to IconPageNum-1 do
      begin
        bnColor[I] := EditColor[I];
        bnPruchod[I] := EditPruchod[I];
      end;
    end;
  end;
end;

procedure TEditForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
  begin
    Close;
    Key := 0;
  end;
end;

procedure TEditForm.FormCreate(Sender: TObject);
var Bitmap: TBitmap;
begin
  Height := 393;
  Width := 628;
  EditBarva := 15;
  EditTrans := -1;

  LoadResTxt;

{ pprava editanho bufferu }
  EditBitmap := TBitmap.Create;
  EditBitmap.Width := IconXNum*IconWidth;
  EditBitmap.Height := IconYNum*IconHeight;
  EditBitmap.Palette := MainForm.InitPal;

{ pprava menu barev }
  Bitmap := TBitmap.Create;
  Bitmap.Width := ColWidth;
  Bitmap.Height := ColHeight*16+15;
  ImageColor.Picture.Graphic := Bitmap;
  ImageColor.Picture.Bitmap.Palette := MainForm.InitPal;

  EditForm.ButtonVlevo.Glyph.Palette := MainForm.InitPal;
  EditForm.ButtonVpravo.Glyph.Palette := MainForm.InitPal;
  EditForm.ButtonNahoru.Glyph.Palette := MainForm.InitPal;
  EditForm.ButtonDolu.Glyph.Palette := MainForm.InitPal;
  EditForm.ButtonEnter.Glyph.Palette := MainForm.InitPal;
  EditForm.ButtonEsc.Glyph.Palette := MainForm.InitPal;

{ pprava okna editoru }
  Bitmap := TBitmap.Create;
  Bitmap.Width := PanelImageEdit.Width;
  Bitmap.Height := PanelImageEdit.Height;
  ImageEdit.Picture.Graphic := Bitmap;
  ImageEdit.Picture.Bitmap.Palette := MainForm.InitPal;

  Bitmap := TBitmap.Create;
  Bitmap.Width := 2*IconWidth;
  Bitmap.Height := 2*IconHeight;
  ImageEnter.Picture.Graphic := Bitmap;
  ImageEnter.Picture.Bitmap.Palette := MainForm.InitPal;

  Bitmap := TBitmap.Create;
  Bitmap.Width := 2*IconWidth;
  Bitmap.Height := 2*IconHeight;
  ImageEsc.Picture.Graphic := Bitmap;
  ImageEsc.Picture.Bitmap.Palette := MainForm.InitPal;
end;

procedure TEditForm.LoadResTxt;
begin
  EditaceTxt := LoadResString(IDS_CAPTION+9);
  ImageColor.Hint := LoadResString(IDS_EDIT+0);
  BoxPruchod.Caption := LoadResString(IDS_EDIT+1);
  BoxPruchod.Hint := LoadResString(IDS_EDIT+2);
  ButtonNahoru.Hint := LoadResString(IDS_EDIT+3);
  ButtonVpravo.Hint := LoadResString(IDS_EDIT+4);
  ButtonDolu.Hint := LoadResString(IDS_EDIT+5);
  ButtonVlevo.Hint := LoadResString(IDS_EDIT+6);
  ImageEnter.Hint := LoadResString(IDS_EDIT+7);
  ButtonEnter.Hint := LoadResString(IDS_EDIT+8);
  ImageEsc.Hint := LoadResString(IDS_EDIT+9);
  ButtonEsc.Hint := LoadResString(IDS_EDIT+10);
  SaveDialogEdit.Title := LoadResString(IDS_EDIT+11);
  SaveDialogEdit.Filter := LoadResString(IDS_EDIT+12);
  EditModiText := LoadResString(IDS_EDIT+13);
end;

procedure TEditForm.FormDestroy(Sender: TObject);
begin
  EditBitmap.Free;
end;

procedure TEditForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var I: Integer;
begin
  CanClose := True;
  if EditModi then
  begin
    I:= MessageDlg(EditModiText,mtConfirmation, mbYesNoCancel,0);
    if I = mrCancel then CanClose := False;
    if I = mrYes then CanClose := EditUloz;
  end;
end;

procedure TEditForm.ButtonEscClick(Sender: TObject);
begin
  Close;
end;

procedure TEditForm.FormShow(Sender: TObject);
var I: Integer;
    Banka: Integer;
begin
  if EditName = '' then EditName := 'BALTIK';
  Caption := EditName + EditaceTxt;
  Banka := (Tag-1) div 1000;
  EditModi := False;
  with EditBitmap do
  begin
    Canvas.Brush.Color := clBlack;
    if Assigned(SelBanks^[Banka]^.bnBitmap) then
      Assign(SelBanks^[Banka]^.bnBitmap)
    else
      Canvas.FillRect(Rect(0,0,Width,Height));
  end;
  for I := 0 to IconPageNum-1 do
  begin
    EditColor[I] := SelBanks^[Banka]^.bnColor[I];
    EditPruchod[I] := SelBanks^[Banka]^.bnPruchod[I];
  end;
  FormResize(Sender);
end;

procedure TEditForm.FormResize(Sender: TObject);
begin
  EditXNum := 2*IconWidth;
  EditYNum := 2*IconHeight;

  EditWidth := PanelImageEdit.Width div (IconWidth*2);
  if EditWidth < 2 then EditWidth := 2;
  EditHeight := PanelImageEdit.Height div (IconHeight*2);
  if EditHeight < 2 then EditHeight := 2;
  if EditWidth < EditHeight then
    EditHeight := EditWidth
  else
    EditWidth := EditHeight;

{  EditXNum := ImageEdit.Width div EditWidth;
  if EditXNum < IconWidth+2 then EditXNum := IconWidth+2;
  EditYNum := ImageEdit.Height div EditHeight;
  if EditYNum < IconHeight+2 then EditYNum := IconHeight+2;}

  ImageEdit.Picture.Bitmap.Width := EditXNum*EditWidth;
  ImageEdit.Picture.Bitmap.Height := EditYNum*EditHeight;
  ImageEdit.Left := (PanelImageEdit.Width - EditXNum*EditWidth) div 2;
  ImageEdit.Top := (PanelImageEdit.Height - EditYNum*EditHeight) div 2;

  Zobraz;
end;

procedure TEditForm.Zobraz;
var I,J,K,L: Integer;
    Ikona: Integer;
    SRect,DRect,LRect,BRect: TRect;
begin
  LabelEditNum.Caption := IntToStr(Tag);
  Ikona := (Tag-1) mod 1000;
  with ImageEdit.Canvas do
  begin
    I := (Ikona mod IconXNum)*IconWidth - IconWidth div 2;
    J := (Ikona div IconXNum)*IconHeight - IconHeight div 2;
    K := I + EditXNum;
    L := J + EditYNum;

    BRect := Rect(0,0,2*IconWidth,2*IconHeight);
    LRect := BRect;

    if I < 0 then
    begin
      I := 0;
      LRect.Left := IconWidth div 2;
    end;

    if J < 0 then
    begin
      J := 0;
      LRect.Top := IconHeight div 2;
    end;

    if K >= IconWidth*IconXNum then
    begin
      K := IconWidth*IconXNum-1;
      LRect.Right := IconWidth div 2 + IconWidth;
    end;

    if L >= IconHeight*IconYNum then
    begin
      L := IconHeight*IconYNum-1;
      LRect.Bottom := IconHeight div 2 + IconHeight;
    end;

    SRect := Rect(I,J,K,L);
    DRect := Rect(0,0,EditXNum*EditWidth,EditYNum*EditHeight);

    with ImageEnter.Picture.Bitmap.Canvas do
    begin
      Brush.Color := clBlack;
      Brush.Style := bsSolid;
      FillRect(BRect);
    end;

    ImageEnter.Picture.Bitmap.Canvas.CopyRect(
                LRect,EditBitmap.Canvas,SRect);

    with ImageEsc.Canvas do
    begin
      Brush.Color := clBlack;
      Brush.Style := bsSolid;
      FillRect(BRect);
    end;

    if Assigned(SelBanks^[(Tag-1) div 1000]^.bnBitmap) then
      ImageEsc.Picture.Bitmap.Canvas.CopyRect(LRect,
        SelBanks^[(Tag-1) div 1000]^.bnBitmap.Canvas,SRect);

    CopyRect(DRect,ImageEnter.Picture.Bitmap.Canvas,BRect);

    Pen.Color := clGray;
    Pen.Style := psSolid;
    Pen.Width := 1;
    for I := 1 to EditXNum-1 do
    begin
      MoveTo(I*EditWidth-1,0);
      LineTo(I*EditWidth-1,EditYNum*EditHeight);
    end;

    for I := 1 to EditYNum-1 do
    begin
      MoveTo(0,I*EditHeight-1);
      LineTo(EditXNum*EditWidth,I*EditHeight-1);
    end;

    Pen.Color := clWhite;

    MoveTo((IconWidth div 2)*EditWidth-1,0);
    LineTo((IconWidth div 2)*EditWidth-1,EditYNum*EditHeight);
    MoveTo((IconWidth div 2 + IconWidth)*EditWidth-1,0);
    LineTo((IconWidth div 2 + IconWidth)*EditWidth-1,EditYNum*EditHeight);

    MoveTo(0,(IconHeight div 2)*EditHeight-1);
    LineTo(EditXNum*EditWidth,(IconHeight div 2)*EditHeight-1);
    MoveTo(0,(IconHeight div 2 + IconHeight)*EditHeight-1);
    LineTo(EditXNum*EditWidth,(IconHeight div 2 + IconHeight)*EditHeight-1);
  end;

  if Ikona >= IconXNum then
    ButtonNahoru.Enabled := True
  else
    ButtonNahoru.Enabled := False;

  if Ikona <= IconPageNum-IconXNum then
    ButtonDolu.Enabled := True
  else
    ButtonDolu.Enabled := False;

  if Ikona mod IconXNum > 0 then
    ButtonVlevo.Enabled := True
  else
    ButtonVlevo.Enabled := False;

  if Ikona mod IconXNum < IconXNum-1 then
    ButtonVpravo.Enabled := True
  else
    ButtonVpravo.Enabled := False;

  ZobrazCol;
end;

procedure TEditForm.ZobrazCol;
var I: Integer;
    LRect: TRect;
begin
  EditTrans := EditColor[(Tag-1) mod 1000];
  BoxPruchod.Checked := EditPruchod[(Tag-1) mod 1000] <> 1;

{ vykreslen menu barev }
  with ImageColor.Picture.Bitmap.Canvas do
  begin
    Brush.Style := bsSolid;
    Brush.Color := clBtnFace;
    Pen.Width := 1;
    Pen.Style := psSolid;
    Pen.Mode := pmCopy;
    FillRect(Rect(0,0,Width,Height));
    for I := 0 to 15 do
    begin
      LRect := Rect(1,I*(ColHeight+1)+1,ColWidth-1,I*(ColHeight+1)+ColHeight-1);

      Pen.Color := clBtnShadow;
      MoveTo(0,LRect.Bottom-1);
      LineTo(0,LRect.Top-1);
      LineTo(LRect.Right,LRect.Top-1);

      Pen.Color := clBtnHighlight;
      MoveTo(1,LRect.Bottom);
      LineTo(LRect.Right,LRect.Bottom);
      LineTo(LRect.Right,LRect.Top-1);

      Brush.Color := $1000000+I;
      FillRect(LRect);

      if I = EditBarva then
      begin
        Case EditBarva of
          0,8: Pen.Color := clWhite
        else Pen.Color := clBlack;
        end;
        MoveTo(LRect.Left,LRect.Top);
        LineTo(LRect.Right-1,LRect.Top);
        LineTo(LRect.Right-1,LRect.Bottom-1);
        LineTo(LRect.Left,LRect.Bottom-1);
        LineTo(LRect.Left,LRect.Top);

        MoveTo(LRect.Left+1,LRect.Top+1);
        LineTo(LRect.Right-2,LRect.Top+1);
        LineTo(LRect.Right-2,LRect.Bottom-2);
        LineTo(LRect.Left+1,LRect.Bottom-2);
        LineTo(LRect.Left+1,LRect.Top+1);
      end;

      if I = EditTrans then
      begin
        Case EditTrans of
          0..8: Font.Color := clWhite
        else Font.Color := clBlack;
        end;
        Brush.Style := bsClear;
        TextOut(LRect.Left+8,LRect.Top+1,'T');
        Brush.Style := bsSolid;
      end;
    end;
  end;
end;

procedure TEditForm.ButtonNahoruClick(Sender: TObject);
begin
  if (Tag-1) mod 1000 >= IconXNum then
  begin
    Tag := Tag - IconXNum;
    Zobraz;
  end;
end;

procedure TEditForm.ButtonDoluClick(Sender: TObject);
begin
  if (Tag-1) mod 1000 <= (IconPageNum-IconXNum) then
  begin
    Tag := Tag + IconXNum;
    Zobraz;
  end;
end;

procedure TEditForm.ButtonVlevoClick(Sender: TObject);
begin
  if ((Tag-1) mod 1000) mod IconXNum > 0 then
  begin
    Tag := Tag - 1;
    Zobraz;
  end;
end;

procedure TEditForm.ButtonVpravoClick(Sender: TObject);
begin
  if ((Tag-1) mod 1000) mod IconXNum < IconXNum-1 then
  begin
    Tag := Tag + 1;
    Zobraz;
  end;
end;

procedure TEditForm.ImageEditMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var I,J: Integer;
begin
  I := X; { - (PanelImageEdit.Width - ImageEdit.Picture.Bitmap.Width) div 2;}
  J := Y; { - (PanelImageEdit.Height - ImageEdit.Picture.Bitmap.Height) div 2;}
  if (I >= (IconWidth div 2)*EditWidth) and
     (I < (IconWidth div 2 + IconWidth)*EditWidth) and
     (J >= (IconHeight div 2)*EditHeight) and
     (J < (IconHeight div 2 + IconHeight)*EditHeight) then
  begin
    ImageEdit.Hint :=
        '| X = ' + IntToStr(I div EditWidth - IconWidth div 2)
      + ',' + #9 + ' Y = ' + IntToStr(J div EditHeight - IconHeight div 2);
    if ssLeft in Shift then
      ImageEditMouseDown(Sender,mbLeft,Shift,X,Y);
  end
  else
    ImageEdit.Hint := '';
  if ssRight in Shift then
    ImageEditMouseDown(Sender,mbRight,Shift,X,Y);
end;

procedure TEditForm.ImageColorMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var I: Integer;
    Ikona: Integer;
begin
  Ikona := (Tag-1) mod 1000;
  if Button = mbLeft then
  begin
    if (Y >= 0) and (Y < (ColHeight+1)*16) then
      EditBarva := Y div (ColHeight+1);
    ZobrazCol;
  end;
  if Button = mbRight then
  begin
    if (Y >= 0) and (Y < (ColHeight+1)*16) then
    begin
      I := Y div (ColHeight+1);
      if I = EditTrans then
        EditTrans := -1
      else
        EditTrans := I;
      EditColor[Ikona] := EditTrans;
      EditModi := True;
    end;
    ZobrazCol;
  end;
end;

procedure TEditForm.ImageEditMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var I,J,K,L: Integer;
    C, D, D0: Longint;
    R,G,B: Byte;
    Ikona: Integer;
begin
  I := X; { - (ImageEdit.Width - ImageEdit.Picture.Bitmap.Width) div 2;}
  J := Y; { - (ImageEdit.Height - ImageEdit.Picture.Bitmap.Height) div 2;}

  if (I >= 0) and (I < 2*IconWidth*EditWidth) and
     (J >= 0) and (J < 2*IconHeight*EditHeight) then
  begin
    I := I div EditWidth;
    J := J div EditHeight;

    if Button = mbRight then
    begin
      C := ImageEnter.Picture.Bitmap.Canvas.Pixels[I,J] and $ffffff;
      D := 256*256*256;
      R := C and $ff;
      G := (C div 256) and $ff;
      B := (C div 256 div 256) and $ff;
      for K := 0 to 15 do
      begin
        D0 := Abs(DefPalette[K*4]-R) + Abs(DefPalette[K*4+1]-G)
              + Abs(DefPalette[K*4+2]-B);
        if D > D0 then
        begin
          D := D0;
          EditBarva := K;
        end;
      end;
      ZobrazCol;
    end;

    if (Button = mbLeft) then
    begin
      if I < IconWidth div 2 - 3 then
        ButtonVlevoClick(Sender);
      if I > IconWidth div 2 + IconWidth + 2 then
        ButtonVpravoClick(Sender);
      if J < IconHeight div 2 - 3 then
        ButtonNahoruClick(Sender);
      if J > IconHeight div 2 + IconHeight + 2 then
        ButtonDoluClick(Sender);

      if (I >= IconWidth div 2) and
         (I < IconWidth div 2 + IconWidth) and
         (J >= IconHeight div 2) and
         (J < IconHeight div 2 + IconHeight) then
      begin
        Ikona := (Tag - 1) mod 1000;
        K := Ikona mod IconXNum;
        L := Ikona div IconXNum;

        EditBitmap.Canvas.Pixels[K*IconWidth + I - IconWidth div 2,
             L*IconHeight + J - IconHeight div 2] :=
               EditBarva + $1000000;
        EditModi := True;
        ImageEnter.Canvas.Pixels[I,J] := EditBarva + $1000000;

        with ImageEdit.Canvas do
        begin
          Brush.Style := bsSolid;
          Brush.Color := EditBarva + $1000000;
          FillRect(Rect(I*EditWidth,J*EditHeight,
            I*EditWidth+EditWidth-1,
            J*EditHeight+EditHeight-1));
        end;

      end;
    end;


  end;
end;

procedure TEditForm.ButtonEnterClick(Sender: TObject);
begin
  EditUloz;
end;

function TEditForm.EditUloz: Boolean;   { TRUE = pokraovat }
var Cislo: Longint;
    Pripona: string;
begin
  Result := False;
  Cislo := (Tag-1) div 1000;
  case Cislo of
        0..9: SaveDialogEdit.DefaultExt := 'B0' + IntToStr(Cislo);
      10..99: SaveDialogEdit.DefaultExt := 'B'  + IntToStr(Cislo);
    100..109: SaveDialogEdit.DefaultExt := 'C0' + IntToStr(Cislo-100);
    else      SaveDialogEdit.DefaultExt := 'C'  + IntToStr(Cislo-100);
  end;
  SaveDialogEdit.InitialDir := EditAktDir;
  SaveDialogEdit.FileName := EditName+'.'+SaveDialogEdit.DefaultExt;
  if SaveDialogEdit.Execute then
  begin
    Screen.Cursor := crHourGlass;

    EditAktDir := ExtractFilePath(SaveDialogEdit.FileName);
    EditName := ExtractFileName(SaveDialogEdit.FileName);
    if Pos('.',EditName) > 0 then
      Delete(EditName,Pos('.',EditName),200);

    Pripona := AnsiUpperCase(ExtractFileExt(SaveDialogEdit.FileName));
    if Pos('.',Pripona) > 0 then
      Delete(Pripona,Pos('.',Pripona),1);
    Pripona[1] := Chr(Ord(Pripona[1])-Ord('B')+Ord('0'));
    Cislo := StrToIntDef(Pripona,-1);
    if(Cislo >= 0) and (Cislo < MaxBank) then
      EditForm.Tag := (EditForm.Tag-1) mod 1000 + Cislo*1000 + 1;

    Caption := EditName + EditaceTxt;

    SaveBanka(SaveDialogEdit.FileName);
    StorBank(@SceneBank, SceneName, AktDirScene);
    StorBank(@ProgramBank, ProgramName, AktDirProgram);

    Screen.Cursor := crDefault;
    EditModi := False;
    Result := True;
    Zobraz;
  end;
end;

procedure TEditForm.BoxPruchodClick(Sender: TObject);
var Ikona: Integer;
    Pruchod: Integer;
begin
  if BoxPruchod.Checked then
    Pruchod := 0
  else
    Pruchod := 1;

  Ikona := (Tag-1) mod 1000;
  if EditPruchod[Ikona] <> Pruchod then
  begin
    EditPruchod[Ikona] := Pruchod;
    EditModi := True;
  end;
end;

procedure SaveBanka(Jmeno: string);
var I,J,K,L,M,N: Integer;
    R,G,B: Byte;
    D, D0: Integer;
    StreamOut: TMemoryStream;
    BankBitmap: ^TBankBitmap;
    Barva: TColor;
    Barva0: Byte;
begin
  StreamOut := TMemoryStream.Create;
  New(BankBitmap);
  try { finaly }
      with BankBitmap^.BankIcon[0] do
      begin
        biData[0] := Ord('B');
        biData[1] := Ord('A');
        biData[2] := Ord('N');
        biData[3] := Ord('K');
        for I := 0 to 15 do
        begin
          biData[I*3+4]   := DefPalette[I*4]   div 4;
          biData[I*3+4+1] := DefPalette[I*4+1] div 4;
          biData[I*3+4+2] := DefPalette[I*4+2] div 4;
        end;
      end;
      StreamOut.Clear;
      StreamOut.SetSize(SizeHeadBank+IconPageNum*SizeOf(TBankIcon));
      StreamOut.Position := 0;
      StreamOut.WriteBuffer(BankBitmap^.BankIcon[0].biData,SizeHeadBank);

      for I := 0 to IconYNum-1 do
      begin
        for J := 0 to IconXNum-1 do
        begin
          with BankBitmap^.BankIcon[J] do
          begin
            biLastX := 38;
            biPruchod := EditPruchod[I*IconXNum+J];
            biLastY := 28;
            biMaskCol := EditColor[I*IconXNum+J];
            FillChar(biData,SizeOf(biData),0);
            biRes3 := $d8;
            biRes4 := $d3;
            for K := 0 to IconHeight-1 do
              for L := 0 to IconWidth-1 do
              begin
                Barva := EditBitmap.Canvas.Pixels[
                           L+J*IconWidth,K+I*IconHeight];
                R := Barva and $ff;
                G := (Barva div 256) and $ff;
                B := (Barva div 256 div 256) and $ff;
                D := 256+256+256;

                Barva0 := 0;
                for M := 0 to 15 do
                begin
                  D0 := Abs(DefPalette[M*4]-R)
                       + Abs(DefPalette[M*4+1]-G)
                       + Abs(DefPalette[M*4+2]-B);
                  if D0 < D then
                  begin
                    D := D0;
                    Barva0 := M;
                  end;
                end;

                M := 1 shl (7-L and 7);

                N := K*(IconWidthL div 2) + L div 8;
                if (Barva0 and 8) <> 0 then
                  biData[N] := biData[N] or M;

                N := N + IconWidthL div 8;
                if (Barva0 and 4) <> 0 then
                  biData[N] := biData[N] or M;

                N := N + IconWidthL div 8;
                if (Barva0 and 2) <> 0 then
                  biData[N] := biData[N] or M;

                N := N + IconWidthL div 8;
                if (Barva0 and 1) <> 0 then
                  biData[N] := biData[N] or M;

              end;
          end;
        end;
        StreamOut.WriteBuffer(BankBitmap^, SizeOf(TBankBitmap));
      end;
      StreamOut.SaveToFile(Jmeno);
    finally
      Dispose(BankBitmap);
    end;  { try }
  StreamOut.Free;
end;

end.
